function log_trans_dens = trans_dens_d_and_m(current_value, prev_value, model_params, mdl_trans_mtx, t)

% log_trans_dens = trans_dens_d_and_m(current_value, prev_value,
% model_params, mdl_trans_mtx, t)
%


% First, extract the pmf for the length of the segment:
% pmf = str2func(model_params{prev_value.M}.seg_length_pmf_name);
% Obtain the parameters for that pmf:

PM  = prev_value.M;
PD  = prev_value.D;
CM  = current_value.M;
CD  = current_value.D;

params = model_params{PM}.seg_length_pmf_params;

% Calculate the needed values of the pmf and the corresponding cmf:
if (CD == PD)&&(CM == PM)
%     G = sum(pmf(1:t-PD-2, params));
%     g = pmf(t-1-PD, params);
%     log_trans_dens = log(1- g/(1-G));
    log_trans_dens = log(1 - params.success_prob);
elseif CD == t-1
%     G = sum(pmf(1:t-PD-2, params));
%     g = pmf(t-1-PD, params);    
%     log_trans_dens = log(g/(1-G)) + log(mdl_trans_mtx(PM, CM));
    log_trans_dens = log(params.success_prob) + log(mdl_trans_mtx(PM, CM));
else
    log_trans_dens = -inf;
end